//+------------------------------------------------------------------+
//|                                                        Sound.mq4 |
//|                                                           Kirill |
//|                                          StockProgrammer@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Kirill"
#property link      "StockProgrammer@mail.ru"

/*
1., ,   MN  1.
2.     N- .
3. ()   Hight and Low.
4.        Nn-.
5. ()  .
6.       "X" , 
 .            <<   !
 /      .
     .
7.     .
8.      .
10.     0,01  1.00 .
 .
*/

/*
v3.5+
  .
 SAR.

 .
SAR      ,   .
   .
      .
*/


extern int     Magic =  1036;
extern bool    LOAD_DATA      =  false;
extern int     N     =  8;      //     
extern int     M     =  4;      //     
extern int     X     =  0;      // 
extern double  lots  =  0.1;
extern string  comment1       =  " MA ";
extern bool    UseMAFilter    =  true;
extern int     period         =  55;
extern int     ma_shift       =  0;
extern int     ma_method      =  1;
extern int     applied_price  =  4;
extern string  comment2       =  " SAR ";
extern int     UseSARFilter   =  true;
extern double  SAR_step       =  0.02;
extern double  SAR_maximum    =  0.2;
extern bool    CloseOrderIfCantTrail   = true;
extern bool    EnableMonthlyProfit     = true;
extern bool    RestartProfitCount      = false;
extern int     MaxEquity               = 120;     //%    (   )
extern int     MinEquity               = 80;      //%    (   )
extern string  soundfile   =  "      _\sounds   . : alert.wav";

int Y = 0;                 //     .    .     - SAVE()  LOAD().
int slip = 5;
datetime    timeflag = 0;
int t = 0;
double lo1, hi1, lo2, hi2;
int month = -1;
int critical = 0;

int Ticket[1000];      

string CommentArray[7];

int init()
{
   CommentArray[0] = "Sound v3.5" + "\n" + "  www.FX4U.ru";

   if(LOAD_DATA == true)
      LOAD();
      
   if(!GlobalVariableCheck("Semaphore_sound"))
      GlobalVariableSet("Semaphore_sound", 0.0);    //0.0 - , 1.0 -    

   ObjectCreate("lo1", OBJ_TREND, 0, Time[N], Low[N], Time[0], Low[N]);
   ObjectSet("lo1", OBJPROP_RAY, false);
   ObjectSet("lo1", OBJPROP_COLOR, Red);
   
   ObjectCreate("hi1", OBJ_TREND, 0, Time[N], High[N], Time[0], High[N]);
   ObjectSet("hi1", OBJPROP_RAY, false);
   ObjectSet("hi1", OBJPROP_COLOR, Red);
   
   ObjectCreate("lo2", OBJ_TREND, 0, Time[M], Low[M], Time[0], Low[M]);
   ObjectSet("lo2", OBJPROP_RAY, false);
   ObjectSet("lo2", OBJPROP_COLOR, LawnGreen);
   
   ObjectCreate("hi2", OBJ_TREND, 0, Time[M], High[M], Time[0], High[M]);
   ObjectSet("hi2", OBJPROP_RAY, false);
   ObjectSet("hi2", OBJPROP_COLOR, LawnGreen);
   
   ObjectCreate("SLLEVEL", OBJ_TREND, 0, 0, 0, 0, 0);
   ObjectSet("SLLEVEL", OBJPROP_RAY, false);
   ObjectSet("SLLEVEL", OBJPROP_COLOR, Gold);
         
   return(0);
}

int deinit()
{
   Alert("Deinit. Saving data to file \"Sound_" + DoubleToStr(Magic, 0) + ".csv\"");
   SAVE();
   ObjectsDeleteAll();
   if(critical == 1)
   {
      GlobalVariableSet("Semaphore_sound",      0.0);    // ,   ,      
      GlobalVariableSet("Semaphore_sound_2_MP", 0.0);    // ,   ,      
   }  
   return(0);
}

int start()
{
   bool AllowTrades = true;
   
   if(EnableMonthlyProfit)       //     
      if(MonthlyProfit() == 0)      //      
         AllowTrades = false;                    // 
 
   if(AllowTrades == true)
   {
      datetime lastbar = Time[0];
      if(timeflag < lastbar)
      {      
         timeflag = lastbar;
      
         SAVE();              //
      
         lo2 = Low[M];
         hi2 = High[M];      
      
      
         if(t>0)
         {
            OrderSelect(t, SELECT_BY_TICKET);
            if(OrderCloseTime() != 0)
               t=0;
            else              //   
            {
               LevelStopLoss();
               return (0);             
            }
         }
      
    
         lo1 = Low[N];
         hi1 = High[N];
   
         ObjRedraw();
         SlRedraw(0.0);
   
         double ma   =  iMA(NULL, 0, period, ma_shift, ma_method, applied_price, 0);
         double sar  =  iSAR(NULL, 0, SAR_step, SAR_maximum, 0);
         double sl;
         if(Open[0] >= hi1 + X*Point)   //  BUY
         {
            if(UseMAFilter == false || Bid > ma)
            {
               if(UseSARFilter == false || sar > ma)
               {
                  sl = lo2;
                  SlRedraw(sl);
                  if(Bid - sl < (MarketInfo(Symbol(),MODE_STOPLEVEL)+2)*Point) {CommentArray[1] = "  -    -"; return(0);}
                  SemaphoreTake("Semaphore_sound");
                  t = OrderSend(Symbol(), OP_BUY, lots, Ask, slip, sl, 0, NULL, Magic);
                  SemaphoreReturn("Semaphore_sound");
                  if(t<0) Alert("BUY Order Send Error: ", GetLastError());
                  else
                     {PlaySound(soundfile); CommentArray[1] = " #" + DoubleToStr(t,0) + ":    "; SAVE();}
               }
               else
                  CommentArray[1] = "  - SAR   ";
            }
            else
               CommentArray[1] = "  -    ";
         }
   
         else if(Open[0] <= lo1 - X*Point)
         {
            if(UseMAFilter == false || Bid < ma)
            {
               if(UseSARFilter == false || sar < ma)
               {            
                  sl = hi2;
                  SlRedraw(sl);
                  if(sl - Ask < (MarketInfo(Symbol(),MODE_STOPLEVEL)+2)*Point) {CommentArray[1] = "  -    -"; return(0);}
                  SemaphoreTake("Semaphore_sound");
                  t = OrderSend(Symbol(), OP_SELL, lots, Bid, slip, sl, 0, NULL, Magic);
                  SemaphoreReturn("Semaphore_sound");
                  if(t<0) Alert("SELL Order Send Error: ", GetLastError());
                  else
                     {PlaySound(soundfile); CommentArray[1] = " #" + DoubleToStr(t,0) + ":    "; SAVE();}
               }
               else
                  CommentArray[1] = "  - SAR   ";
            }
            else
               CommentArray[1] = "  -    ";         
         }
         else
            CommentArray[1] = "   X ";
      
      
      }
   }
   
   PrintComment();
      
   return(0);
}

void ObjRedraw()
{
   ObjectSet("lo1", OBJPROP_TIME1, Time[N]);
   ObjectSet("lo1", OBJPROP_PRICE1, Low[N]);
   ObjectSet("lo1", OBJPROP_TIME2, Time[0]);
   ObjectSet("lo1", OBJPROP_PRICE2, Low[N]);
   
   ObjectSet("hi1", OBJPROP_TIME1, Time[N]);
   ObjectSet("hi1", OBJPROP_PRICE1,High[N]);
   ObjectSet("hi1", OBJPROP_TIME2, Time[0]);
   ObjectSet("hi1", OBJPROP_PRICE2,High[N]);   
   
   ObjectSet("lo2", OBJPROP_TIME1, Time[M]);
   ObjectSet("lo2", OBJPROP_PRICE1, Low[M]);
   ObjectSet("lo2", OBJPROP_TIME2, Time[0]);
   ObjectSet("lo2", OBJPROP_PRICE2, Low[M]);
   
   ObjectSet("hi2", OBJPROP_TIME1, Time[M]);
   ObjectSet("hi2", OBJPROP_PRICE1,High[M]);
   ObjectSet("hi2", OBJPROP_TIME2, Time[0]);
   ObjectSet("hi2", OBJPROP_PRICE2,High[M]); 
}

void SAVE()
{
   int handle = FileOpen("Sound_" + DoubleToStr(Magic, 0) + ".csv", FILE_CSV | FILE_WRITE);
   if(handle<0) Alert("File Open Error: ", GetLastError());  
   
   int res    = FileWrite( handle, N, M, X, Y, lots, slip, timeflag, t, lo1, hi1, lo2, hi2, UseMAFilter, period, ma_shift, ma_method, applied_price, UseSARFilter, SAR_step, SAR_maximum, CloseOrderIfCantTrail, EnableMonthlyProfit, RestartProfitCount, MinEquity, MaxEquity );
   if(res < 0)  Alert("File Write Attempt Failed. Error: ", GetLastError());   
   FileClose(handle); 
   
   handle = FileOpen("Sound_" + DoubleToStr(Magic, 0) + ".csv", FILE_BIN | FILE_READ | FILE_WRITE);
   FileSeek(handle, 0, SEEK_END);
   res        = FileWriteString( handle, soundfile, StringLen(soundfile) );
   if(res < 0)  Alert("File Write Attempt Failed. Error: ", GetLastError());
   FileClose(handle); 

   Print("Saved Parameters: ", N, " ", M, " ", X, " ", Y, " ", lots, " ", slip, " ", timeflag, " ", t, " ", lo1, " ", hi1, " ", lo2, " ", hi2, " ", UseMAFilter, " ", period, " ", ma_shift, " ", ma_method, " ", applied_price, " ", UseSARFilter, " ", SAR_step, " ", SAR_maximum, " ", CloseOrderIfCantTrail, " ", EnableMonthlyProfit, " ", RestartProfitCount, " ", MinEquity, " ", MaxEquity, " ", soundfile );
     
}

void LOAD()
{
   int i, res;
   
   int handle = FileOpen("Sound_" + DoubleToStr(Magic, 0) + ".csv", FILE_CSV | FILE_READ);
   if(handle<0) Alert("File Open Error: ", GetLastError());    
   
   N                       =  FileReadNumber(handle);
   M                       =  FileReadNumber(handle);
   X                       =  FileReadNumber(handle);
   Y                       =  FileReadNumber(handle);
   lots                    =  FileReadNumber(handle);
   slip                    =  FileReadNumber(handle);
   timeflag                =  FileReadNumber(handle);
   t                       =  FileReadNumber(handle);
   lo1                     =  FileReadNumber(handle);
   hi1                     =  FileReadNumber(handle);
   lo2                     =  FileReadNumber(handle);
   hi2                     =  FileReadNumber(handle);
   UseMAFilter             =  FileReadNumber(handle);
   period                  =  FileReadNumber(handle);
   ma_shift                =  FileReadNumber(handle);
   ma_method               =  FileReadNumber(handle);
   applied_price           =  FileReadNumber(handle);
   UseSARFilter            =  FileReadNumber(handle);
   SAR_step                =  FileReadNumber(handle);
   SAR_maximum             =  FileReadNumber(handle);
   CloseOrderIfCantTrail   =  FileReadNumber(handle);
   EnableMonthlyProfit     =  FileReadNumber(handle);
   RestartProfitCount      =  FileReadNumber(handle);
   MinEquity               =  FileReadNumber(handle);
   MaxEquity               =  FileReadNumber(handle);   
   soundfile               =  FileReadString(handle);
   
   FileClose(handle);   
   
   Alert("Loaded Parameters: ", N, " ", M, " ", X, " ", Y, " ", lots, " ", slip, " ", timeflag, " ", t, " ", lo1, " ", hi1, " ", lo2, " ", hi2, " ", UseMAFilter, " ", period, " ", ma_shift, " ", ma_method, " ", applied_price, " ", UseSARFilter, " ", SAR_step, " ", SAR_maximum, " ", CloseOrderIfCantTrail, " ", EnableMonthlyProfit, " ", RestartProfitCount, " ", MinEquity, " ", MaxEquity, " ", soundfile );
   
   Alert("Load successfull. Continuing work.");  
}


int LevelStopLoss()
{
   double sl;
   int res, k;
   OrderSelect(t, SELECT_BY_TICKET);
   
   if(OrderType() == OP_BUY)
   {   
         sl = lo2;
         SlRedraw(sl);
         if(Bid - sl < (MarketInfo(Symbol(),MODE_STOPLEVEL)+2)*Point) 
         {
            if(CloseOrderIfCantTrail == false)
               {CommentArray[1] = " #" + DoubleToStr(t,0) + ":    .   -"; return(0);}
            else
            {
               SemaphoreTake("Semaphore_sound");
               res = OrderClose(OrderTicket(), OrderLots(), Bid, slip, Gold);
               SemaphoreReturn("Semaphore_sound");
               if(res==true)
                  {CommentArray[1] = " #" + DoubleToStr(t,0) + ":      "; return(0);}
               else
                  {CommentArray[1] = " #" + DoubleToStr(t,0) + ":    .    "; return(0);}        
            }
         }
         SemaphoreTake("Semaphore_sound");
         res = OrderModify(t, 0, sl, 0, 0); 
         SemaphoreReturn("Semaphore_sound");
         if(res == true)
            CommentArray[1] = " #" + DoubleToStr(t,0) + ":    . - ";
         else
            {k=GetLastError(); if(k!=1) CommentArray[1] = " #" + DoubleToStr(t,0) + ":    .   -: \n" + DoubleToStr(GetLastError(),0) + "  ";}   
   }
   
   else if(OrderType() == OP_SELL)
   {   
         sl = hi2;
         SlRedraw(sl);
         if(sl - Ask < (MarketInfo(Symbol(),MODE_STOPLEVEL)+2)*Point) 
         {
            if(CloseOrderIfCantTrail == false)
               {CommentArray[1] = " #" + DoubleToStr(t,0) + ":    .   -"; return(0);}
            else
            {
               SemaphoreTake("Semaphore_sound");
               res = OrderClose(OrderTicket(), OrderLots(), Ask, slip, Gold);            
               SemaphoreReturn("Semaphore_sound");
               if(res==true)
                  {CommentArray[1] = " #" + DoubleToStr(t,0) + ":      "; return(0);}
               else
                  {CommentArray[1] = " #" + DoubleToStr(t,0) + ":    .    "; return(0);}        
            }
         }
         SemaphoreTake("Semaphore_sound");
         res = OrderModify(t, 0, sl, 0, 0); 
         SemaphoreReturn("Semaphore_sound");
         if(res == true)
            CommentArray[1] = " #" + DoubleToStr(t,0) + ":    . - ";    
         else
            {k=GetLastError(); if(k!=1) CommentArray[1] = " #" + DoubleToStr(t,0) + ":    .   -: \n" + DoubleToStr(GetLastError(),0) + "  ";}   
              
   }
   
   SlRedraw(sl);

}

void SlRedraw(double sl)
{
   ObjectSet("SLLEVEL", OBJPROP_TIME1, Time[M]);
   ObjectSet("SLLEVEL", OBJPROP_PRICE1, sl);
   ObjectSet("SLLEVEL", OBJPROP_TIME2, Time[0]+Period()*120);
   ObjectSet("SLLEVEL", OBJPROP_PRICE2, sl);
}


//+-------------------------------------------------------------------+

void SemaphoreTake(string SEM)
{ 
   if(GlobalVariableCheck(SEM) == false)
      GlobalVariableSet(SEM, 0);
  
   while(1==1)
   {
      if(GlobalVariableSetOnCondition(SEM, 1.0, 0.0))         // 
      {
         critical = 1;
         Print("SEMAPHORE \"", SEM, "\" TAKEN. CURRENT VALUE: ", GlobalVariableGet(SEM));
         break;      //    
      }
      else
      {
         Print("ATTEMPT TO CAPTURE SEMAPHORE \"", SEM, "\" FAILED. SEMAPHORE BUSY. WAITING 0.1 SEC. CURRENT VALUE: ", GlobalVariableGet(SEM));
         Sleep(100);
      }
   }
} 

void SemaphoreReturn(string SEM)
{
   GlobalVariableSet(SEM, 0.0);
   Print("SEMAPHORE \"", SEM, "\" RETURNED. CURRENT VALUE: ", GlobalVariableGet(SEM));
   critical = 0;
}
 
//---------------------------------------------------------------------
//gAllowed, gMonth, gStartingEquity
int MonthlyProfit()
{
   int ret = 1;
   
   SemaphoreTake("Semaphore_sound_2_MP");
   
      if(GlobalVariableCheck("gAllowed") == false)          //   
      {
         GlobalVariableSet("gAllowed", 1);
         GlobalVariableSet("gMonth", Month());
         GlobalVariableSet("gStartingEquity", AccountEquity());
      }
   
      double _Allowed, _Month, _StartingEquity;
      _Month            = GlobalVariableGet("gMonth");
   
      if(RestartProfitCount == true || Month() != _Month)   //        
      {
         GlobalVariableSet("gAllowed", 1);
         GlobalVariableSet("gMonth", Month());
         GlobalVariableSet("gStartingEquity", AccountEquity());
         RestartProfitCount = false;
      }

      _Month            = GlobalVariableGet("gMonth");
      _Allowed          = GlobalVariableGet("gAllowed");
      _StartingEquity   = GlobalVariableGet("gStartingEquity");
   
      if(_Allowed < 0.0)   ret = 0;
   
   //-------------------------------------------------------
      else
      {
         double EquityNow = AccountEquity();
   
         CommentArray[2] = "Month Starting Equity: " + DoubleToStr(_StartingEquity, 2);
         CommentArray[3] = "Current Equity:           " + DoubleToStr(EquityNow, 2);
   
         if( NormalizeDouble(EquityNow, 2) < NormalizeDouble((MinEquity/100.0)*_StartingEquity,2) )
         {
            Alert("Current Equity Is < ", MinEquity, "% * Starting Equity Of This Month.\nTrades Stopped.");
            CloseAllOrders();
            GlobalVariableSet("gAllowed", -1);                 //    
            CommentArray[4] = "Trades Stopped At: " + TimeToStr(TimeCurrent()) + "\n" +
                              "Reason: " + DoubleToStr(EquityNow, 2) + " < " + DoubleToStr(MinEquity/100.0, 2) + "*" + DoubleToStr(_StartingEquity, 2) + "\n" +
                              "Trades Will Recommence At The Beggining Of Next Month";
            ret = 0;
         }
      
         if( NormalizeDouble(EquityNow, 2) > NormalizeDouble((MaxEquity/100.0)*_StartingEquity,2) )
         {
            Alert("Current Equity Is > ", MaxEquity, "% * Starting Equity Of This Month.\nTrades Stopped.");
            CloseAllOrders();
            GlobalVariableSet("gAllowed", -1);                 //    
            CommentArray[4] = "Trades Stopped At: " + TimeToStr(TimeCurrent()) + "\n" +
                              "Reason: " + DoubleToStr(EquityNow, 2) + " > " + DoubleToStr(MaxEquity/100.0, 2) + "*" + DoubleToStr(_StartingEquity, 2) + "\n" +
                              "Trades Will Recommence At The Beggining Of Next Month";
            ret = 0;
         }
   
         if(ret!=0)
         {
            CommentArray[4] = "Min Equity:  " + DoubleToStr(MinEquity/100.0, 2) + "*" + DoubleToStr(_StartingEquity, 2) + " = " + DoubleToStr((MinEquity/100.0)*_StartingEquity,2) + "\n" +
                              "Max Equity: " + DoubleToStr(MaxEquity/100.0, 2) + "*" + DoubleToStr(_StartingEquity, 2) + " = " + DoubleToStr((MaxEquity/100.0)*_StartingEquity,2) + "\n" +
                              "Equity OK:  "  + DoubleToStr((MinEquity/100.0)*_StartingEquity,2) + " < " + DoubleToStr(EquityNow, 2) + " < " + DoubleToStr((MaxEquity/100.0)*_StartingEquity,2);
         }                     
      }
      
   SemaphoreReturn("Semaphore_sound_2_MP"); 

   return(ret);

}  

void CloseAllOrders()
{
   int res, i, total = OrdersTotal();
   
   Alert("!!! CLOSING ALL ORDERS !!!");
   Print("! Closing all orders performed by robot: Magic = ", Magic, " Symbol = ", Symbol());
   
   total = CreateTicketArrayAll(OP_BUY);   
   for(i=0; i<total; i++)
   {
      OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Closing OP_BUY Order #", OrderTicket());
      SemaphoreTake("Semaphore_sound");
      res = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_BID), slip, White);         
      SemaphoreReturn("Semaphore_sound");
      if(res < 0) Alert("OrderClose Error: ", GetLastError());
   }
   
   total = CreateTicketArrayAll(OP_SELL);   
   for(i=0; i<total; i++)
   {
      OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Closing OP_SELL Order #", OrderTicket());
      SemaphoreTake("Semaphore_sound");
      res = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_ASK), slip, White);         
      SemaphoreReturn("Semaphore_sound");
      if(res < 0) Alert("OrderClose Error: ", GetLastError());
   }

   total = CreateTicketArrayAll(OP_BUYSTOP); 
   for(i=0; i<total; i++)
   {
      OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Deleting OP_BUYSTOP Order #", OrderTicket());
      SemaphoreTake("Semaphore_sound");
      res = OrderDelete(OrderTicket()); 
      SemaphoreReturn("Semaphore_sound");
      if(res < 0) Alert("OrderDelete Error: ", GetLastError());   
   }

   total = CreateTicketArrayAll(OP_SELLSTOP);
   for(i=0; i<total; i++)
   {
      OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Deleting OP_SELLSTOP Order #", OrderTicket());
      SemaphoreTake("Semaphore_sound");
      res = OrderDelete(OrderTicket()); 
      SemaphoreReturn("Semaphore_sound");
      if(res < 0) Alert("OrderDelete Error: ", GetLastError());   
   }

   total = CreateTicketArrayAll(OP_BUYLIMIT); 
   for(i=0; i<total; i++)
   {
      OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Deleting OP_BUYLIMIT Order #", OrderTicket());
      SemaphoreTake("Semaphore_sound");
      res = OrderDelete(OrderTicket()); 
      SemaphoreReturn("Semaphore_sound");
      if(res < 0) Alert("OrderDelete Error: ", GetLastError());   
   }
   
   total = CreateTicketArrayAll(OP_SELLLIMIT); 
   for(i=0; i<total; i++)
   {
      OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Deleting OP_SELLLIMIT Order #", OrderTicket());
      SemaphoreTake("Semaphore_sound");
      res = OrderDelete(OrderTicket()); 
      SemaphoreReturn("Semaphore_sound");
      if(res < 0) Alert("OrderDelete Error: ", GetLastError());   
   }      
}

int CreateTicketArrayAll(int dir)
{
   int total=OrdersTotal(), i, c=0; if (total<=0) return (0);
	for(i=0;i<total;i++) { OrderSelect(i, SELECT_BY_POS); if (OrderType()==dir) { Ticket[c] = OrderTicket(); c++; } }
	return (c);
}

void PrintComment()
{
   Comment(CommentArray[0], "\n",
           "Current Situation: ", CommentArray[1], "\n",
           "-------------------------------\n",
           CommentArray[2], "\n",
           CommentArray[3], "\n",
           CommentArray[4], "\n",
           CommentArray[5], "\n",
           CommentArray[6], "\n");
}